/*
 $License:
    Copyright (C) 2011 InvenSense Corporation, All Rights Reserved.
 $
 */

/******************************************************************************
 *
 * $Id:$
 *
 *****************************************************************************/

#include <string.h>

#include "progressiveNoMotion.h"
#include "gyroBias.h"
#include "ml.h"
#include "mlFIFO.h"
#include "mlmath.h"
#include "mlsupervisor.h"
#include "mlMathFunc.h"

/*
    Define
*/
#define PROGNOMOTION_DEBUG 0

/*
    Data Structures
*/
struct _PNM {
};

/*
    Globals 
*/
extern tMLSupervisorCB ml_supervisor_cb;

struct _PNM pnmData;

/*
    Prototypes
*/
tMLError MLProgressiveNoMotionSupervisor(unsigned long deltaTime);

/*
    Functions
*/

/**
 *  @brief  Enable the progressive no motion algorithm.
 *  @return ML_ERROR_FEATURE_NOT_IMPLEMENTED
 */
tMLError MLEnableProgressiveNoMotion(void)
{
    return ML_ERROR_FEATURE_NOT_IMPLEMENTED;
}

/**
 *  @brief  Disable the progressive no motion algorithm.
 *  @return ML_SUCCESS == 0.
 */
tMLError MLDisableProgressiveNoMotion(void)
{
    return ML_SUCCESS;
}

int ProgressiveNoMotionIsEnabled(void)
{
    return 0;
}

/**
 *  @brief  Reset the progressive no motion algorithm internal state.
 *  @return ML_SUCCESS == 0.
 */
tMLError MLProgressiveNoMotionReset(void)
{
    return ML_ERROR_FEATURE_NOT_IMPLEMENTED;
}

/**
 *  @brief  When biases changed, this could impact the data in the FIFO such 
 *          that some gyro data will have different biases from other gyro 
 *          data. This causes a time delay that allows some data to flush 
 *          from the FIFO before continuing the algorithm.
 */
void ProgressiveNoMotionBiasChanged(void)
{
    return;
}

int ProgressiveNoMotionGetState(void)
{
    if (mlxData.mlMotionState == ML_NO_MOTION) {
        return PROG_NO_MOTION;
    } else {
        return PROG_MOTION;
    } 
}

tMLError MLProgressiveNoMotionSupervisor(unsigned long deltaTime)
{    
    return ML_SUCCESS;
}

/**
 *  @}
 */

